%define lib_name_orig libalsa
%define major 2
%define lib_name %mklibname alsa %major
%define beta 0
%if %beta
%define fname alsa-lib-%{version}%beta
%else
%define fname alsa-lib-%{version}
%endif

Summary:	Advanced Linux Sound Architecture (ALSA) library
Name:		libalsa2
Version:	1.0.25
%if %beta
Release:	%mkrel 0.%{beta}.1
%else
Release:	%mkrel 3
%endif
Source0:	ftp://ftp.alsa-project.org/pub/lib/%{fname}.tar.bz2
Source1:	README.soundprofiles
# (cg) Upstream cherry picks
Patch0100:	0100-conf-pcm-Add-support-for-Echo3G-devices.-Thanks-to-u.patch
Patch0101:	0101-USB-Audio-Blacklist-iec958-for-some-USB-devices.patch
Patch0102:	0102-USB-Audio-Fixup-card-name-for-Logitech-web-camera.patch
Patch0103:	0103-mixer-Remove-redundant-CHECK_ENUM-from-snd_mixer_sel.patch
Patch0104:	0104-seqmid-more-descriptions-on-snd_seq_parse_address-be.patch
License:	LGPLv2+
Epoch:		2
Url:		http://www.alsa-project.org/
Group:		Sound
Provides:	alsa-lib = %epoch:%version-%release
Provides:	%lib_name_orig = %epoch:%version-%release
Obsoletes:	alsa-lib < %epoch:%version-%release
Obsoletes:	%lib_name_orig < %epoch:%version-%release
Suggests:	%{_lib}alsa-plugins
BuildRequires:	doxygen python-devel
Requires:	%{lib_name_orig}-data

%description
Advanced Linux Sound Architecture (ALSA) is a modularized architecture which
supports quite a large range of ISA and PCI cards.
It's fully compatible with old OSS drivers (either OSS/Lite, OSS/commercial).
To use the features of alsa, one can either use:
- the old OSS api
- the new ALSA api that provides many enhanced features.

Using the ALSA api requires to use the ALSA library.

%if "%{_lib}" != "lib"
%package -n %{lib_name}
Summary:	Advanced Linux Sound Architecture (ALSA) library
Group:		Sound
Provides:	alsa-lib = %epoch:%version-%release
Provides:	%lib_name_orig = %epoch:%version-%release
Obsoletes:	alsa-lib < %epoch:%version-%release
Obsoletes:	%lib_name_orig < %epoch:%version-%release
Requires:	%{lib_name_orig}-data

%description -n %{lib_name}
Advanced Linux Sound Architecture (ALSA) is a modularized architecture which
supports quite a large range of ISA and PCI cards.
It's fully compatible with old OSS drivers (either OSS/Lite, OSS/commercial).
To use the features of alsa, one can either use:
- the old OSS api
- the new ALSA api that provides many enhanced features.

Using the ALSA api requires to use the ALSA library.
%endif

%define alt_name soundprofile
%define alt_priority 10

%package -n %{lib_name_orig}-data
Summary:    Config files for Advanced Linux Sound Architecture (ALSA)
Group:      Sound
Requires:   %lib_name = %epoch:%version
Requires(post): update-alternatives
Requires(postun): update-alternatives

%description -n %{lib_name_orig}-data
Advanced Linux Sound Architecture (ALSA) is a modularized architecture which
supports quite a large range of ISA and PCI cards.
It's fully compatible with old OSS drivers (either OSS/Lite, OSS/commercial).
To use the features of alsa, one can either use:
- the old OSS api
- the new ALSA api that provides many enhanced features.

This package contains config files by ALSA applications.

%post -n %{lib_name_orig}-data
%{_sbindir}/update-alternatives \
  --install %{_sysconfdir}/sound/profiles/current %{alt_name} %{_sysconfdir}/sound/profiles/alsa %{alt_priority}

%postun -n %{lib_name_orig}-data
if [ ! -f %{_sysconfdir}/sound/profiles/alsa/profile.conf ]; then
  /usr/sbin/update-alternatives --remove %{alt_name} %{_sysconfdir}/sound/profiles/alsa
fi

%package -n %{lib_name}-devel
Summary:    Development files for Advanced Linux Sound Architecture (ALSA)
Group:      Development/C
Requires:   %lib_name = %epoch:%version
Provides:   libalsa1-devel = %epoch:%version-%release
Provides:   alsa-lib-devel = %epoch:%version-%release
Provides:   %lib_name_orig-devel = %epoch:%version-%release
Obsoletes:   libalsa1-devel < %epoch:%version-%release
Obsoletes:   alsa-lib-devel < %epoch:%version-%release
Obsoletes:   %lib_name_orig-devel < %epoch:%version-%release
# (cg) As of 1.0.25 you cannot build static and shared together...
# so lets just obsolete the static-devel
Obsoletes:  %{lib_name}-static-devel < 2:1.0.25

%description -n %{lib_name}-devel
Advanced Linux Sound Architecture (ALSA) is a modularized architecture which
supports quite a large range of ISA and PCI cards.
It's fully compatible with old OSS drivers (either OSS/Lite, OSS/commercial).
To use the features of alsa, one can either use:
- the old OSS api
- the new ALSA api that provides many enhanced features.

This package contains files needed in order to develop an application
that made use of ALSA.

%package docs
Summary:    Documentation for Advanced Linux Sound Architecture (ALSA)
Group:      Books/Howtos
Requires:   %lib_name = %epoch:%version
BuildArch:  noarch

%description docs
Advanced Linux Sound Architecture (ALSA) is a modularized architecture which
supports quite a large range of ISA and PCI cards.
It's fully compatible with old OSS drivers (either OSS/Lite, OSS/commercial).
To use the features of alsa, one can either use:
- the old OSS api
- the new ALSA api that provides many enhanced features.

The Advanced Linux Sound Architecture comes with a kernel API and library API.
This document describes the library API and how it interfaces with the kernel
API. Application programmers should use the library API rather than kernel API.

The Library offers 100% of the functionally of the kernel API, but add next
major improvements in usability, making the application code simpler and better
looking.

This package contains the documentation that describe tha ALSA lib API.

%prep
%setup -q -n %fname
%apply_patches

%build
autoreconf -if
%configure2_5x --enable-shared --enable-python
# Force definition of -DPIC so that VERSIONED_SYMBOLS are used
# FIXME: alsa people should not depend on PIC to determine a DSO build...
perl -pi -e 's,(^pic_flag=.+)(-fPIC),\1-DPIC \2,' libtool

%make
%make -C doc doc

%install
rm -rf %{buildroot}
%makeinstall_std

# (cg) For sound profile support
mkdir -p %{buildroot}%{_sysconfdir}/sound/profiles/alsa
echo "SOUNDPROFILE=alsa" >%{buildroot}%{_sysconfdir}/sound/profiles/alsa/profile.conf
echo "# This file is left blank to allow alsa to default to dmix" >%{buildroot}%{_sysconfdir}/sound/profiles/alsa/alsa-default.conf
install -m 644 %SOURCE1 %{buildroot}%{_sysconfdir}/sound/profiles/README
ln -s %{_sysconfdir}/sound/profiles/current/alsa-default.conf %{buildroot}%{_datadir}/alsa/alsa.conf.d/99-default.conf


rm -f %{buildroot}%{_libdir}/alsa-lib/smixer/*.la
rm -f %{buildroot}%{_libdir}/*.la

%clean
rm -rf %{buildroot}

%files -n %{lib_name_orig}-data
%defattr(-, root, root)
%doc COPYING
%dir %{_sysconfdir}/sound/profiles
%dir %{_sysconfdir}/sound/profiles/alsa
%{_sysconfdir}/sound/profiles/README
%{_sysconfdir}/sound/profiles/alsa/profile.conf
%{_sysconfdir}/sound/profiles/alsa/alsa-default.conf
%dir %_datadir/alsa/
%dir %_datadir/alsa/alsa.conf.d/
%dir %_datadir/alsa/cards/
%dir %_datadir/alsa/pcm/
%_datadir/alsa/alsa.conf.d/*
%_datadir/alsa/cards/*
%_datadir/alsa/pcm/*
%_datadir/alsa/alsa.conf
%_datadir/alsa/smixer.conf
%_datadir/alsa/sndo-mixer.alisp

%files -n %{lib_name}
%defattr(-, root, root)
%doc COPYING 
%_libdir/*.so.%{major}*
%dir %_libdir/alsa-lib
%dir %_libdir/alsa-lib/smixer/
%_libdir/alsa-lib/smixer/*

%files docs
%defattr(-,root,root)
%doc COPYING doc/doxygen/html/* doc/asoundrc.txt

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc COPYING
%dir %_includedir/alsa/
%_includedir/alsa/*
%_includedir/sys/asoundlib.h
%_datadir/aclocal/alsa.m4
%_libdir/*.so
%_libdir/pkgconfig/*.pc
%_bindir/*


%changelog

* Sat Apr 07 2012 fwang <fwang> 2:1.0.25-3.mga2
+ Revision: 229476
- cleanup provides and obsoletes

* Thu Mar 15 2012 colin <colin> 2:1.0.25-2.mga2
+ Revision: 223548
- Add upstream patches (cosmetic+penum over-application fix)
- Remove old patch files

* Wed Jan 25 2012 colin <colin> 2:1.0.25-1.mga2
+ Revision: 201522
- New version: 1.0.25
- Dropped static library (upstream no longer support shared+static builds)

* Mon Jan 23 2012 dmorgan <dmorgan> 2:1.0.24.1-7.mga2
+ Revision: 200149
- Own %%_libdir/alsa-lib

  + colin <colin>
    - Revert previous change (the link is correct - something else is wrong). mga#2966

  + eatdirt <eatdirt>
    - Fix wrong link to alsa-default.conf (BUG 2966)

* Mon Sep 19 2011 colin <colin> 2:1.0.24.1-6.mga2
+ Revision: 145632
- Fix sound on the non-PA profile.

* Sat Sep 17 2011 colin <colin> 2:1.0.24.1-5.mga2
+ Revision: 144501
- Use an upstream submitted patch for more flexible config without patching

* Thu Sep 15 2011 fwang <fwang> 2:1.0.24.1-4.mga2
+ Revision: 143769
- drop .la files

* Tue Apr 26 2011 colin <colin> 2:1.0.24.1-3.mga1
+ Revision: 91704
- Various upstream cherry-picks for increased compatibility (esp. with PA)

* Thu Mar 24 2011 boklm <boklm> 2:1.0.24.1-2.mga1
+ Revision: 76162
- rebuild for bug #497

* Tue Mar 08 2011 ahmad <ahmad> 2:1.0.24.1-1.mga1
+ Revision: 66340
- update to 1.0.24.1
- drop the patches that were merged upstream
- don't run autoreconf, not needed AFAICS
- fix license

* Mon Jan 17 2011 blino <blino> 2:1.0.23-9.mga1
+ Revision: 21221
- rebuild with new python

* Sun Jan 09 2011 ahmad <ahmad> 2:1.0.23-8.mga1
+ Revision: 1574
- imported package libalsa2

